import { AbstractParseTreeVisitor, Lexer as LexerType, Parser as ParserType } from 'antlr4ng';
import { CursorPosition } from './lib/cursor.js';
import { TokenDictionary } from './lib/tables.js';
import { AutocompleteResultBase, ClickHouseAutocompleteResult, ColumnAliasSuggestion, ColumnSuggestion, EngineSuggestion, GenerateSuggestionsFromRules, GetParseTree, ISymbolTableVisitor, KeywordSuggestion, LexerConstructor, MySqlAutocompleteResult, ParserConstructor, ParserSyntaxError, PostgreSqlAutocompleteResult, SymbolTableVisitorConstructor, TableOrViewSuggestion } from './types.js';
export { CursorPosition } from './lib/cursor.js';
export { AutocompleteResultBase, TableOrViewSuggestion, KeywordSuggestion, ParserSyntaxError, ColumnSuggestion, ColumnAliasSuggestion, EngineSuggestion, };
export declare function parseQuery<A extends AutocompleteResultBase, L extends LexerType, P extends ParserType, S extends ISymbolTableVisitor & AbstractParseTreeVisitor<{}>>(Lexer: LexerConstructor<L>, Parser: ParserConstructor<P>, SymbolTableVisitor: SymbolTableVisitorConstructor<S>, tokenDictionary: TokenDictionary, ignoredTokens: Set<number>, preferredRules: Set<number>, explicitlyParseJoin: boolean, getParseTree: GetParseTree<P>, generateSuggestionsFromRules: GenerateSuggestionsFromRules<A>, query: string, cursor: CursorPosition): AutocompleteResultBase;
export declare function parseMySqlQueryWithoutCursor(query: string): Pick<MySqlAutocompleteResult, 'errors'>;
export declare function parseMySqlQuery(query: string, cursor: CursorPosition): MySqlAutocompleteResult;
export declare function parsePostgreSqlQueryWithoutCursor(query: string): Pick<PostgreSqlAutocompleteResult, 'errors'>;
export declare function parsePostgreSqlQuery(query: string, cursor: CursorPosition): PostgreSqlAutocompleteResult;
export declare function parseClickHouseQueryWithoutCursor(query: string): Pick<ClickHouseAutocompleteResult, 'errors'>;
export declare function parseClickHouseQuery(query: string, cursor: CursorPosition): ClickHouseAutocompleteResult;
